# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b152"
os.chdir("/Users/was/notebook/misc/worksheets/admin/142/cells/11")
sage.server.notebook.interact.SAGE_CELL_ID=11
def bisect_method(f, a, b, eps):
    try:
        f = f._fast_float_(f.variables()[Integer(0)])
    except AttributeError:
        pass
    intervals = [(a,b)]
    two = float(Integer(2)); eps = float(eps)
    while True:
        c = (a+b)/two
        fa = f(a); fb = f(b); fc = f(c)
        if abs(fc) < eps: return c, intervals
        if fa*fc < Integer(0):
            a, b = a, c
        elif fc*fb < Integer(0):
            a, b = c, b
        else:
            raise ValueError, "f must have a sign change in the interval (%s,%s)"%(a,b)
        intervals.append((a,b))

html("<h1>Double Precision Root Finding Using Bisection</h1>")
@interact
def _(f = cos(x) - x, a = float(Integer(0)), b = float(Integer(1)), eps=(Integer(3),(ellipsis_iter(Integer(1),Ellipsis,Integer(20))))):
     eps = Integer(10)**(-eps)
     print "eps = %s"%float(eps)
     try:
         __time__=misc.cputime(); __wall__=misc.walltime();  c, intervals = bisect_method(f, a, b, eps); print         "Time: CPU %.2f s, Wall: %.2f s"%(misc.cputime(__time__), misc.walltime(__wall__))
     except ValueError:
         print "f must have opposite sign at the endpoints of the interval"
         show(plot(f, a, b, color='red'), xmin=a, xmax=b)
     else:
         print "root =", c
         print "f(c) = %r"%f(c)
         print "iterations =", len(intervals)
         P = plot(f, a, b, color='red')
         h = (P.ymax() - P.ymin())/ (Integer(3)*len(intervals))
         L = sum(line([(c,h*i), (d,h*i)]) for i, (c,d) in enumerate(intervals) )
         L += sum(line([(c,h*i-h/Integer(4)), (c,h*i+h/Integer(4))]) for i, (c,d) in enumerate(intervals) )
         L += sum(line([(d,h*i-h/Integer(4)), (d,h*i+h/Integer(4))]) for i, (c,d) in enumerate(intervals) )
         show(P + L, xmin=a, xmax=b)
         html('%s'%intervals)

print "e152"
