# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b502"
os.chdir("/Users/was/notebook/misc/worksheets/admin/142/cells/26")
sage.server.notebook.interact.SAGE_CELL_ID=26
def newton_method(f, c, eps, maxiter=Integer(100)):
    x = f.variables()[Integer(0)]
    fprime = f.derivative(x)
    try:
        g = f._fast_float_(x)
        gprime = fprime._fast_float_(x)
    except AttributeError:
        g = f; gprime = fprime
    iterates = [c]
    for i in xrange(maxiter):
       fc = g(c)
       if abs(fc) < eps: return c, iterates
       c = c - fc/gprime(c)
       iterates.append(c)
    return c, iterates



html("<h1>Double Precision Root Finding Using Newton's Method</h1>")

@interact
def _(f = x**Integer(2) - Integer(2), c = float(RealNumber('0.5')), eps=(-Integer(3),(ellipsis_iter(-Integer(10),Ellipsis,-Integer(1)))), interval=float(RealNumber('0.5'))):
     eps = Integer(10)**(eps)
     print "eps = %s"%float(eps)
     __time__=misc.cputime(); __wall__=misc.walltime();  z, iterates = newton_method(f, c, eps); print         "Time: CPU %.2f s, Wall: %.2f s"%(misc.cputime(__time__), misc.walltime(__wall__))
     print "root =", z
     print "f(c) = %r"%f(z)
     n = len(iterates)
     print "iterations =", n
     P = plot(f, z-interval, z+interval, rgbcolor='blue')
     h = P.ymax(); j = P.ymin()
     L = sum(point((w,(n-Integer(1)-float(i))/n*h), rgbcolor=(float(i)/n,RealNumber('0.2'),RealNumber('0.3')), pointsize=Integer(10)) +              line([(w,h),(w,j)],rgbcolor='black',thickness=RealNumber('0.2')) for i,w in enumerate(iterates))
     show(P + L, xmin=z-interval, xmax=z+interval)

print "e502"
