# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b643"
os.chdir("/Users/was/notebook/misc/worksheets/admin/142/cells/66")
sage.server.notebook.interact.SAGE_CELL_ID=66
print _support_.syseval(html, ur'''
Often $f$ is differentiable and its values can help us give an even more efficient root
finding algorithm called <b>Newton\u0027s Method</b>.

<br><br>
The equation of the tangent line to the graph of $f(x)$ at the point $(c,f(c))$
is 
$$
   y = f(c) + f\u0027(c)(x-c).
$$
This is because the above line goes through the point $(c,f(c))$ and is a line of slow $f\u0027(c)$.

<br><br><b>Newton\u0027s method: </b>
Approximate $f(x)$ by the line above, find a root of that line, then replace $c$
by that root.  Iterate.  In particular, by easy algebra, the root of the linear function 
is 
$$c - \frac{f(c)}{f\u0027(c)}.$$ 

<br><br> As an algorithm:
<ol>
<li> Choose a starting value $c$. 
<li> Let $c = c - f(c)/f\u0027(c)$. 
<li> If $|f(c)| < \epsilon$ output $c$ and terminate.
  Otherwise, go to 2.
<ol>''', '/Users/was/notebook/misc/worksheets/admin/142/cells/66')

print "e643"
